/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_INDEX_H
#define DPC_IMPL_TYPE_INDEX_H

#include "impl_type_uint8.h"

namespace dpc {
struct Index {
    ::UInt8 x{ 0U };
    ::UInt8 y{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(x);
        fun(y);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(x);
        fun(y);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("x", x);
        fun("y", y);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("x", x);
        fun("y", y);
    }

    friend bool operator==(const ::dpc::Index& lhs, const ::dpc::Index& rhs) noexcept
    {
        return (lhs.x == rhs.x) && (lhs.y == rhs.y);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_INDEX_H
